package com.example.julian.endlessroll.entities;

import com.example.julian.endlessroll.data.Vector;
import com.example.julian.endlessroll.entities.collision.geometry.Quad;
import com.example.julian.endlessroll.entities.textures.Texture;

/**
 * Created by Julian on 20.11.2015.
 */
public class Entity extends Quad {

    private Texture texture;
    private Vector movement;
    private float rotation;
    private float alpha = 1.0f;
    private boolean destroyed;
    private DestroyEffect destroyEffect;

    public Entity(Texture texture, Vector position, float width, float height) {
        super(position, width, height);
        this.texture = texture;
        this.movement = new Vector();
    }

    public void move(Vector movement) {
        position.translate(movement);
    }

    public void rotate(float factor) {
        rotation += factor;
    }

    public void setToTerrain(float terrainHeight) {
        position.y = terrainHeight + height / 2;
    }

    public Texture getTexture() {
        return texture;
    }

    public void setTexture(Texture texture) {
        this.texture = texture;
    }

    public Vector getMovement() {
        return movement;
    }

    public void setMovement(Vector movement) {
        this.movement = movement;
    }

    public float getRotation() {
        return rotation;
    }

    public void setRotation(float rotation) {
        this.rotation = rotation;
    }

    public void setAlpha(float alpha) {
        this.alpha = alpha;
    }

    public float getAlpha() {
        return alpha;
    }

    public void destroy(DestroyEffect destroyEffect) {
        this.destroyed = true;
        this.destroyEffect = destroyEffect;
    }

    public boolean isDestroyed() {
        return destroyed;
    }

    public DestroyEffect getDestroyEffect() {
        return destroyEffect;
    }
}
