package com.example.julian.endlessroll.entities.collision.geometry;

import com.example.julian.endlessroll.data.Vector;
import com.example.julian.endlessroll.entities.tools.Ramp;

/**
 * Created by Julian on 01.12.2015.
 */
public class Triangle implements Geometry {

    private Vector vertex1, vertex2, vertex3;

    public Triangle(Ramp ramp) {
        Vector vertex1 = new Vector(ramp.getRightEdge(), ramp.getBottomEdge());
        Vector vertex2 = new Vector(ramp.getRightEdge(), ramp.getTopEdge());
        Vector vertex3 = new Vector(ramp.getLeftEdge(), ramp.getBottomEdge());
        setVertex1(vertex1);
        setVertex2(vertex2);
        setVertex3(vertex3);
    }

    public Triangle(Vector vertex1, Vector vertex2, Vector vertex3) {
        this.vertex1 = vertex1;
        this.vertex2 = vertex2;
        this.vertex3 = vertex3;
    }

    public Vector getVertex1() {
        return vertex1;
    }

    public void setVertex1(Vector vertex1) {
        this.vertex1 = vertex1;
    }

    public Vector getVertex2() {
        return vertex2;
    }

    public void setVertex2(Vector vertex2) {
        this.vertex2 = vertex2;
    }

    public Vector getVertex3() {
        return vertex3;
    }

    public void setVertex3(Vector vertex3) {
        this.vertex3 = vertex3;
    }
}
