package com.example.julian.endlessroll.entities.textures;

import android.content.Context;

import com.example.julian.endlessroll.R;
import com.example.julian.endlessroll.entities.tools.ToolType;

/**
 * Created by Julian on 05.12.2015.
 */
public class TexturePack {

    private TextureLoader loader;

    public final Texture background;
    public final Texture goal;
    public final Texture terrain;
    public final Texture playerArrow;
    public final Texture player;
    public final Texture obstacle;
    public final Texture star;
    public final Texture blueParticle;
    public final Texture yellowParticle;
    public final Texture redParticle;

    public TexturePack(Context context) {
        loader = new TextureLoader(context);
        background = loadTexture(R.drawable.background);
        goal = loadTexture(R.drawable.goal);
        terrain = loadAtlas(R.drawable.terrain, 1, 1);
        player = loadTexture(R.drawable.ball);
        playerArrow = loadTexture(R.drawable.playerarrow);

        obstacle = loadTexture(R.drawable.obstacle);
        star = loadTexture(R.drawable.star);

        blueParticle = loadTexture(R.drawable.blueparticle);
        yellowParticle = loadTexture(R.drawable.yellowparticle);
        redParticle = loadTexture(R.drawable.redparticle);

        ToolType.loadAllToolTextures(this);
    }

    private Texture loadTexture(int id) {
        int texId = loader.loadTextureId(id, false);
        return new Texture(texId, 1, 1);
    }

    public Texture loadAtlas(int id, int atlasWidth, int atlasHeight) {
        int texId = loader.loadTextureId(id, true);
        return new Texture(texId, atlasWidth, atlasHeight);
    }
}
