package com.example.julian.endlessroll.entities.tools;

import com.example.julian.endlessroll.levels.levelup.LevelUpBounties;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Julian on 15.07.2016.
 */
public class ToolSlotSettings extends ArrayList<ToolSlot> {

    public ToolSlotSettings() {
        this(new ToolSlot(ToolType.RAMP, false), new ToolSlot(ToolType.NONE, true), new ToolSlot(ToolType.NONE, true), new ToolSlot(ToolType.NONE, true));
    }

    public ToolSlotSettings(ToolSlot slot1, ToolSlot slot2, ToolSlot slot3, ToolSlot slot4) {
        super(4);
        super.add(slot1);
        super.add(slot2);
        super.add(slot3);
        super.add(slot4);
    }

    public ToolSlotSettings(List<ToolSlot> list) {
        super(list);
    }

    public void reset() {
        super.set(0, new ToolSlot(ToolType.RAMP, false));
        super.set(1, new ToolSlot(ToolType.NONE, true));
        super.set(2, new ToolSlot(ToolType.NONE, true));
        super.set(3, new ToolSlot(ToolType.NONE, true));
    }

    public void changeToolSlotType(int slot, ToolType newType) {
        for (ToolSlot toolSlot : this) {
            if (super.indexOf(toolSlot) == slot)
                toolSlot.setToolType(newType);
            else if (toolSlot.getToolType() == newType)
                toolSlot.setToolType(ToolType.NONE);
        }
    }

    public void unlockSlotsIfLevelReached(int level, LevelUpBounties levelUpBounties) {
        for (int i = 0; i < 4; i++) {
            super.get(i).setLocked(!levelUpBounties.isToolSlotUnlockedAtLevel(i, level));
        }
    }
}
