package com.example.julian.endlessroll.main.game;

import com.example.julian.endlessroll.entities.tools.ToolSlotSettings;

/**
 * Created by Julian on 10.07.2016.
 */
public class User {

    private final int LV_UP_EXP = 25;
    private final int STAR_EXP = 2;
    private int starCount;
    private int level;
    private int levelProgress;
    private boolean showLevelUp = false;
    private ToolSlotSettings toolSlotSettings;

    public User(int starCount, int level, int levelProgress, ToolSlotSettings toolSlotSettings) {
        this.starCount = starCount;
        this.level = level;
        this.levelProgress = levelProgress;
        this.toolSlotSettings = toolSlotSettings;
    }

    public void clearData() {
        starCount = 0;
        level = 1;
        levelProgress = 0;
        showLevelUp = false;
        toolSlotSettings.reset();
    }

    public void increaseStarCount() {
        increaseStarCount(1);
        gainExp(STAR_EXP);
    }

    public void increaseStarCount(int starCount) {
        this.starCount += starCount;
    }

    public void decreaseStarCount(int count){
        this.starCount-=count;
    }

    public void gainLvUpExp() {
        gainExp(LV_UP_EXP);
    }

    private void gainExp(int amount) {
        levelProgress += amount;
        if (levelProgress >= 100) {
            levelProgress -= 100;
            levelUp();
        }
    }

    private void levelUp() {
        level++;
        showLevelUp = true;
    }

    public int getStarCount() {
        return starCount;
    }

    public int getLevel() {
        return level;
    }

    public int getLevelProgress() {
        return levelProgress;
    }

    public boolean isShowLevelUp() {
        return showLevelUp;
    }

    public void levelUpShown() {
        showLevelUp = false;
    }

    public ToolSlotSettings getToolSlotSettings() {
        return toolSlotSettings;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    public void setStarCount(int starCount) {
        this.starCount = starCount;
    }
}
