package com.example.julian.endlessroll.main.screens;

import android.content.Context;
import android.support.annotation.LayoutRes;
import android.view.LayoutInflater;
import android.view.ViewGroup;

/**
 * Created by Julian on 13.02.2016.
 */
public abstract class Screen<V extends ViewGroup> {

    public enum ScreenType {
        START(0), WORLDS(1), LEVELS(2), GAME(3), TOOL_SHOP(4);

        private int inFlipperPosition;

        ScreenType(int inFlipperPosition) {
            this.inFlipperPosition = inFlipperPosition;
        }

        public int getInFlipperPosition() {
            return inFlipperPosition;
        }
    }

    private ScreenType type;
    protected V layout;

    public Screen(ScreenType type, Context context, @LayoutRes int layoutId) {
        this.type = type;
        layout = inflateLayout(context, layoutId);
    }

    private V inflateLayout(Context context, @LayoutRes int layoutId) {
        LayoutInflater inflater = LayoutInflater.from(context);
        return (V) inflater.inflate(layoutId, null);
    }

    public abstract void prepareToBeShown();

    public abstract void onBackKeyDown();

    public ScreenType getType() {
        return type;
    }

    public V get() {
        return layout;
    }

}
