package com.example.julian.endlessroll.views;

import android.content.Context;
import android.support.annotation.DrawableRes;
import android.view.LayoutInflater;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.julian.endlessroll.R;
import com.example.julian.endlessroll.entities.tools.ToolType;

/**
 * Created by Julian on 15.07.2016.
 */
public class BountyMessage {

    private LinearLayout layout;
    private ImageView image;
    private TextView text;

    public BountyMessage(Context context, int starCount) {
        this(context, R.drawable.star, starCount + "");
    }

    public BountyMessage(Context context, ToolType type) {
        this(context, type.getButtonDrawable(), type.getName() + " unlocked");
    }

    public BountyMessage(Context context) {
        this(context, R.drawable.unlockedbutton, "Tool-Slot unlocked");
    }

    private BountyMessage(Context context, @DrawableRes int imageId, String text) {
        findViews(context);
        this.image.setImageResource(imageId);
        this.text.setText(text);
    }

    private void findViews(Context context) {
        LayoutInflater inflater = LayoutInflater.from(context);
        layout = (LinearLayout) inflater.inflate(R.layout.unlock_message, null);
        image = (ImageView) layout.findViewById(R.id.unlockmessage_toolimage);
        text = (TextView) layout.findViewById(R.id.unlockmessage_message);
    }

    public LinearLayout getLayout() {
        return layout;
    }
}
