package com.example.julian.endlessroll.views;

import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.example.julian.endlessroll.R;

/**
 * Created by Julian on 23.04.2016.
 */
public class LevelButton extends RelativeLayout {

    private TextView text;
    private ImageView starImage;
    private ImageView lockImage;

    public LevelButton(Context context, Typeface typeface, OnClickListener clickListener, int level, boolean locked) {
        super(context);
        LayoutInflater inflater = LayoutInflater.from(context);
        inflater.inflate(R.layout.levelbutton, this);
        super.setOnClickListener(clickListener);

        text = (TextView) super.findViewById(R.id.levelbutton_textview);
        text.setTypeface(typeface);
        starImage = (ImageView) super.findViewById(R.id.levelbutton_starimage);
        lockImage = (ImageView) super.findViewById(R.id.levelbutton_lock);

        setLockVisible(locked);
        text.setText("Level: " + level);
    }

    public void setLockVisible(boolean locked) {
        int visibility = locked ? VISIBLE : INVISIBLE;
        lockImage.setVisibility(visibility);
    }

    public void setStarCount(int count) {
        if (count == 0) {
            starImage.setImageResource(R.drawable.stars_0);
        } else if (count == 1) {
            starImage.setImageResource(R.drawable.stars_1);
        } else if (count == 2) {
            starImage.setImageResource(R.drawable.stars_2);
        } else {
            starImage.setImageResource(R.drawable.stars_3);
        }
    }

    public boolean isLocked() {
        if (lockImage.getVisibility() == VISIBLE)
            return true;
        return false;
    }

}
