package com.example.julian.endlessroll.views;

import android.content.Context;
import android.graphics.Typeface;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.julian.endlessroll.R;
import com.example.julian.endlessroll.levels.levelup.LevelUpBounties;

/**
 * Created by Julian on 15.07.2016.
 */
public class LevelupMessage implements View.OnClickListener {

    private Context context;
    private LevelUpBounties levelUpBounties;
    private FrameLayout layout;

    private TextView levelView;
    private TextView text;
    private LinearLayout unlockMessages;

    public LevelupMessage(Context context, Typeface typeface, FrameLayout layout) {
        this.context = context;
        levelUpBounties = new LevelUpBounties();
        this.layout = layout;
        layout.setOnClickListener(this);
        levelView = (TextView) layout.findViewById(R.id.levelup_level);
        levelView.setTypeface(typeface);
        text = (TextView) layout.findViewById(R.id.levelup_text);
        text.setTypeface(typeface);
        unlockMessages = (LinearLayout) layout.findViewById(R.id.levelup_unlocklist);
    }

    public void show(int level) {
        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        params.setMargins(0, 5, 0, 5);

        levelView.setText(level + "");
        layout.setVisibility(View.VISIBLE);
        for (LevelUpBounties.Bounty bounty : levelUpBounties.get(level)) {
            BountyMessage message = bounty.createMessage(context);
            unlockMessages.addView(message.getLayout(), params);
        }
    }

    private void hide() {
        layout.clearAnimation();
        layout.setVisibility(View.INVISIBLE);
        unlockMessages.removeAllViews();
    }

    @Override
    public void onClick(View v) {
        hide();
    }


}
